/** Update component component properties */
try{

    // Init component \see data in component html
    function onInitComponent(data){
        //console.log("[onInitComponent][" + data.source() + "][" + data + "]");
        return true;
    }
    // compones-mainframe.html callback
    function onGuiChangeGateway(sender,gateway,data) {
        //console.log("[onGuiChangeGateway][" + sender.source + "][" + gateway.getProtocol() + "][" + data + "]");
        //return updateProtocol(gateway.getProtocol(),data);
        return true;
    }
    /** On Update Component Function (Required)
     * Update component when some change has occured
     */
    function onUpdateComponent(data){

        var oComponent = data.node();

        //Check
        if(! (oComponent instanceof Component) ){
            throw "oComponent is not a Component instance";
            return false;
        }

        $("[eve-manager-id='UID']").text(oComponent.UId);
        $("[eve-manager-id='type']").text(oComponent.type);

        //Set name
        var $Elem = $componentProperties.find("[eve-manager-id='name']");
        $Elem.val(oComponent.getParamVal("name"));
        

        //Set html name
        $Elem = $("#"+ oComponent.id +" .components-text");
        $Elem.text(oComponent.getParamVal("name"));
        
        //Build gateways
        $Elem = $componentProperties.find("[eve-manager-id='gateway']");
        $.publish("/view/gateways/refresh/dependencies");
        
        //Set gateways
        var $Elem = $componentProperties.find("[eve-manager-id='gateway'] option");
        $componentProperties.find(".protocols").hide();                                             //Hide all protocols
        for(var i = 0; i < $Elem.length; ++i){
            var $currElem = $($Elem[i]);
            var oNode = $currElem.data("eveManagerNode");
            var strProtocol;
            
            //Find gateway
            if(oNode === oComponent.getParamVal("gateway")){
                
                $currElem.prop("selected",true);                                                    //Select gateway
                if(oNode == undefined){ break; }                                                    //If none gateway is selected break for cycle
                
                var oGateway = oNode.getData();                                                     //Get node data (gateway)
                
                strProtocol = oGateway.getProtocol();                                               //Get protocol id
                $componentProperties.find("[eve-manager-protocol='"+ strProtocol +"']").show();     //Show protocol view
                break;
            }
        }
        
        //Set enable history
        $Elem = $componentProperties.find("[eve-manager-id='history']");
        $Elem.prop("checked",oComponent.getParamVal("history"));
        
        //Set enable save last value
        $Elem = $componentProperties.find("[eve-manager-id='savelastvalue']");
        $Elem.prop("checked",oComponent.getParamVal("savelastvalue"));
        
        //Set enable cache
        $Elem = $componentProperties.find("[eve-manager-id='cache']");
        $Elem.prop("checked",oComponent.getParamVal("cache"));


        //Set customData
        $Elem = $componentProperties.find("[eve-manager-id='customData']");
        $Elem.prop("value",oComponent.getParamVal("customData"));


        
        //Set icon
        $Elem = $componentProperties.find("[eve-manager-id='icons']");
        var aIcons = oComponent.getParamVal("icons");
        
        $.publish("/view/components/"+ oComponent.id +"/refresh/parameter",[oComponent,"icons"]);

        var $container = $("[eve-manager-protocol='gui']");

        /* Components */
        var customInsideData="";
        $Elem = $componentProperties.find("[eve-manager-id='gui/components-list']");
        var aWidgetComponents = oComponent.getParamVal("gui/components-list");
        for(var i=0; i<aWidgetComponents.length; ++i){
            console.log(aWidgetComponents[i]);

            var $label = $('<span>' + aWidgetComponents[i].label + '</span>');
            var $select = $('<select></select>');
            var componentType = aWidgetComponents[i].type;

            //$label.text( _D( componentType.capitalizeFirst() ) );
            $label.addClass("widget-components");

            //Get all created components
            var aComponent = application.getComponentsByType( componentType );

            //Append select
            //$select.addClass("widget-components");
            $select.attr("eve-manager-id","gui/components");
            $select.attr("onchange","setDropDownParam(this);");
            $select.data("componentType",aWidgetComponents[i]);

            $container.prepend($select);
            $container.prepend($label);

            //$container.append("<br class='widget-components' /><br class='widget-components' />");

            for(var j=0; j<aComponent.length; ++j){
                var oNode = aComponent[j];
                var oParent = oNode.getParent();
                var oComponentExt = oNode.getData();
                var label = oComponentExt.getParamVal("name");

                //console.log(oParent);
                if(oParent.getData() instanceof Component){
                    label = oParent.getData().getParamVal("name") +" - "+ label;
                }

                //var $option = $("<option>"+ oComponentExt.getParamVal("name") +"</option>");
                var $option = $("<option>"+ label +"</option>");

                $option.val(oComponentExt.UId);
                $option.data("eveManagerNode",oComponentExt);
                $select.append($option);
            }
        }

        $container.prepend('<h5 style="margin-top: 0px;">Components</h5>');

        $Elem = $componentProperties.find("[eve-manager-id='gui/components']");
        var aWidgetComponents = oComponent.getParamVal("gui/components");
        //console.error(aWidgetComponents);
        //console.error(oComponent);

        for(var i=0; i<$Elem.length; ++i){
            var $options = $( $Elem[i] ).find("option");

            //Element is not selected
            if(aWidgetComponents[i] == undefined){
                $( $options[0] ).prop("selected",true);         //Select automatically
                setDropDownParam($Elem[i]);                     //Save automatically

                continue;
            }

            for(var j=0; j<$options.length; ++j){

                var $option = $( $options[j] );
                var key;

                for(var k in aWidgetComponents[i]){
                    key = k;
                    break;
                }

                //console.error($option.val());
                console.log($option.val());
                if( $option.val() == aWidgetComponents[i][key] ){

                    $option.prop("selected",true);              //Select format
                    //console.error($option.id);
                    break;
                }
            }
        }
        //Disable Gateway
        $("#componentproperties [eve-manager-components='mainframe'] [eve-manager-id='gateway']").prop("disabled",true);



        updateCustomData(oComponent);

        $Elem = $componentProperties.find("[eve-manager-id='gui/start-delay']");
        $Elem.val(oComponent.getParamVal("gui/start-delay"));


      //  console.log(oComponent.encodeJSON().[]);


    };
}
catch(err){
    console.error(err);
}
