/**
 * @description Human Interface Device Manager file
 *
 *
 * @author <a href="mailto:info@ilevia.com">info@ilevia.com</a>
 *
 * 
 */
"use strict";

/*
function touchHandler(event)
{
	var touches = event.changedTouches;
	var	first = touches[0];
	var	type = "";
	
	switch(event.type){
		case "touchstart": type = "mousedown"; break;
		case "touchmove":  type= "mousemove"; break;        
		case "touchend":   type= "mouseup"; break;
		default: return;
	}
	
	var simulatedEvent = document.createEvent("MouseEvent");
	simulatedEvent.initMouseEvent(type, true, true, window, 1,
							  first.screenX, first.screenY,
							  first.clientX, first.clientY, false,
							  false, false, false, 0, null);
	
	first.target.dispatchEvent(simulatedEvent);
	event.preventDefault();
}

$(function(){
	document.addEventListener("touchstart", touchHandler, true);
	document.addEventListener("touchmove", touchHandler, true);
	document.addEventListener("touchend", touchHandler, true);
	document.addEventListener("touchcancel", touchHandler, true); 
});
*/

/**
 *
 * @class HidManager
 *
 * @description Human Interface Device Manager class
 *
 *
 * @author <a href="mailto:info@ilevia.com">info@ilevia.com</a>
 *
 * 
 */
function HidManager(){
	var self = this;
	this.cursor = { x: 0, y:0 };
	
	//On mouse move
	this._onmousemove = function(e){

		self.cursor.x = e.pageX;
		self.cursor.y = e.pageY;
	};
	
	$(document).on("mousemove",self._onmousemove);
}

/**
 *
 * @namespace jQuery
 * @class hid
 *
 * @description Human Interface Device Manager jquery
 *
 *
 * @author <a href="mailto:info@ilevia.com">info@ilevia.com</a>
 *
 * 
 */
jQuery.hid = function(arg)
{
	var self = this;
	
	this.hidObj = new HidManager();
	
	switch(arg.toLowerCase()){
		case "uidown":
			return _UI_down;
			break;
		
		case "uiup":
			return _UI_up;
			break;
		
		case "uimove":
			return _UI_move;
			break;
		case "uimousewheel":
			return _UI_mousewheel;
			break;
		case "cursor":
			return self.hidObj.cursor;
			break;
		default:
			console.warn("Invalid argument: "+ arg);
			break;
	}
};

/** Use with event element in input
 *
 */
jQuery.fn.hid = function(arg){
	//Used for event object
	
	
	
	//if(window.Touch == undefined){
		var evt = this[0];
		var _PosX = evt.pageX;
		var _PosY = evt.pageY;
		var _WheelY = evt.originalEvent.wheelDeltaY;
		var _WheelX = evt.originalEvent.wheelDeltaX;
	//}
	
	//Touch devices
	/*if(window.Touch != undefined){
		var touch = evt.originalEvent.touches[0] || evt.originalEvent.changedTouches[0];
		var _PosX = touch.pageX;
		var _PosY = touch.pageY;
		var _WheelY = null;
		var _WheelX = null;
	}*/
	
	switch(arg.toLowerCase()){
		case "uipositionx":
			return _PosX;
			break;
		case "uipositiony":
			return _PosY;
			break;
		case "uiwheely":
			return _WheelY;
			break;
		case "uiwheelx":
			return _WheelX;
			break;
		default:
			console.warn("Invalid argument: "+ arg);
			break;
	}
};