/*
 * Keyboard Shortcut
 *
 *
 * @author <a href="mailto:info@ilevia.com">info@ilevia.com</a>
 *
 *
 * @required <a href="http://jquery.com/">jQuery</a>
 */ 
"use strict";

$(function(){
    
    //Short key 
    $(document).keydown(function(event){
        
        // Disable back key (go back browser operation)
        /*if(event.which == 8){
            event.preventDefault();
            return;
        };*/
        if (event.ctrlKey && event.altKey) {
            return true;
        }
        // Shortcut: ctrl + n
        if(( String.fromCharCode(event.which).toLowerCase() == 'n' && event.ctrlKey) || (event.which == 19)){
            event.preventDefault();
            application.newProject();
            return;
        };

        // Shortcut: ctrl + f
        if(( String.fromCharCode(event.which).toLowerCase() == 'f' && event.ctrlKey) || (event.which == 19)){
            event.preventDefault();
            $("#components-finder").focus();
            return;
        };
        
        // Shortcut: ctrl + s
        if(( String.fromCharCode(event.which).toLowerCase() == 's' && event.ctrlKey) || (event.which == 19)){
            event.preventDefault();
            var oProject = presenter.preferences.getParameter("currentProject");
            var path = (oProject != undefined)?oProject.projectPath:undefined;
            application.saveProject(path);
            return;
        };

        // Shortcut: ctrl + c
        //if(( String.fromCharCode(event.which).toLowerCase() == 'c' && event.ctrlKey) || (event.which == 19)){
        if(( String.fromCharCode(event.which).toLowerCase() == 'c' && event.altKey) || (event.which == 19)){

            //Copy component
            if($("#mycomponents").is(":visible")){
                var oNode = application.getSelectComponent();

                model["copied"] = oNode;
            }
            return;
        };

        // Shortcut: ctrl + v
        //if(( String.fromCharCode(event.which).toLowerCase() == 'v' && event.ctrlKey) || (event.which == 19)){
        if(( String.fromCharCode(event.which).toLowerCase() == 'v' && event.altKey) || (event.which == 19)){
            //Paste component
            if($("#mycomponents").is(":visible")){
                //var oNode = application.getSelectComponent();

                //Check for paste option
                if(model["copied"] != undefined && model["copied"].getData() instanceof Component){
                    var oParentNode;

                    /*if($element.parent().attr("eve-manager-component") == "group"){
                        oParentNode = $element.parent().data("eveManagerNode");
                    }

                    if(model["copied"] != undefined && model["copied"].getData().getType() == "group"){
                        oParentNode = undefined;
                    }*/
                    var oData = { component: model["copied"], parent: undefined};

                    var oJsonComponent = oData.component.encodeJSON();

                    //Duplicate group
                    if(oJsonComponent.type == "group"){
                        var aSerialized = new Array();

                        //Declare recursive function for decode components
                        //var componentsSerialize = function(oNode){
                        var componentsSerialize = function(oNode,oParent){
                            var serialization = oNode.encodeJSON();
                            delete serialization["UId"];
                            delete serialization["parentUId"];

                            var oNewParent = application.addComponent(serialization,oParent);

                            //Push serialization object
                            //aSerialized.push(serialization);

                            for(var i=0;i<oNode.children.length;++i){
                                componentsSerialize(oNode.children[i],oNewParent);
                            }
                        };
                        //componentsSerialize(oData);
                        componentsSerialize(oData.component);
                        //console.error(oData);

                        //console.error(aSerialized);

                        /*
                        var oParent = application.addComponent(aSerialized.shift());
                        while(aSerialized.length > 0){
                            console.error(aSerialized[0]);

                            //delete aSerialized[0]["UId"];
                            //delete aSerialized[0]["parentUId"];

                            application.addComponent(aSerialized.shift(),oParent);
                        }
                        application.selectComponent(oParent);
                        */

                    }
                    //Is component
                    else{
                        delete oJsonComponent.UId;

                        //Choose parent
                        oJsonComponent.parentUId = undefined;

                        //console.warn(oData);
                        application.selectComponent( application.addComponent(oJsonComponent,oData.parent) );
                    }
                }
            }
            return;
        };

        // Shortcut: ctrl + o
        if(( String.fromCharCode(event.which).toLowerCase() == 'o' && event.ctrlKey )){
            event.preventDefault();
            /*var oNode = application.getSelectComponent();
             if(oNode != undefined && oNode.getData().getType() != "group"){
             oNode = undefined;
             }*/
            application.preLoadProject();

            return;
        };



        // Shortcut: ctrl + 0
        if(( String.fromCharCode(event.which).toLowerCase() == '0' && event.ctrlKey)||( String.fromCharCode(event.which).toLowerCase() == 'g' && event.ctrlKey)){
            event.preventDefault();
            /*var oNode = application.getSelectComponent();
            if(oNode != undefined && oNode.getData().getType() != "group"){
                oNode = undefined;
            }*/
            var oNode = application.selectComponent( application.addComponent({ type: "group" }) );
            $("#"+ oNode.getData().id).find("h3").trigger("click");

            return;
        };

        // Shortcut: ctrl + 1
        if(( String.fromCharCode(event.which).toLowerCase() == '1' && event.ctrlKey)){
            event.preventDefault();
            var oNode = application.getSelectComponent();
            if(oNode != undefined && oNode.getData().getType() != "group"){
                oNode = undefined;
            }

            application.addComponent({ type: "switch" },oNode)
            //application.selectComponent( application.addComponent({ type: "switch" },oNode) );
            return;
        };

        // Shortcut: ctrl + 2
        /*if(( String.fromCharCode(event.which).toLowerCase() == '2' && event.ctrlKey)){
            event.preventDefault();
            var oNode = application.getSelectComponent();
            if(oNode != undefined && oNode.getData().getType() != "group"){
                oNode = undefined;
            }
            application.addComponent({ type: "info" },oNode);
            //application.selectComponent( application.addComponent({ type: "info" }) );
            return;
        };*/

        // Shortcut: ctrl + 3
        if(( String.fromCharCode(event.which).toLowerCase() == '3' && event.ctrlKey)){
            event.preventDefault();
            var oNode = application.getSelectComponent();
            if(oNode != undefined && oNode.getData().getType() != "group"){
                oNode = undefined;
            }
            application.addComponent({ type: "slider" },oNode);
            //application.selectComponent( application.addComponent({ type: "slider" }) );
            return;
        };

        // Shortcut: ctrl + 4
        if(( String.fromCharCode(event.which).toLowerCase() == '4' && event.ctrlKey)){
            event.preventDefault();
            var oNode = application.getSelectComponent();
            if(oNode != undefined && oNode.getData().getType() != "group"){
                oNode = undefined;
            }
            application.addComponent({ type: "thermostat" },oNode);
            //application.selectComponent( application.addComponent({ type: "thermostat" }) );
            return;
        };

        // Shortcut: ctrl + 5
        if(( String.fromCharCode(event.which).toLowerCase() == '5' && event.ctrlKey)){
            event.preventDefault();
            var oNode = application.getSelectComponent();
            if(oNode != undefined && oNode.getData().getType() != "group"){
                oNode = undefined;
            }
            application.addComponent({ type: "scenario" },oNode);
            //application.selectComponent( application.addComponent({ type: "rgb-light" }) );
            return;
        };

        // Shortcut: ctrl + 6
        if(( String.fromCharCode(event.which).toLowerCase() == '6' && event.ctrlKey)){
            event.preventDefault();
            var oNode = application.getSelectComponent();
            if(oNode != undefined && oNode.getData().getType() != "group"){
                oNode = undefined;
            }
            application.addComponent({ type: "rgb-light" },oNode);
            //application.selectComponent( application.addComponent({ type: "rgb-light" }) );
            return;
        };

        // Shortcut: ctrl + 7
        if(( String.fromCharCode(event.which).toLowerCase() == '7' && event.ctrlKey)){
            event.preventDefault();
            var oNode = application.getSelectComponent();
            if(oNode != undefined && oNode.getData().getType() != "group"){
                oNode = undefined;
            }
            application.addComponent({ type: "shutter" },oNode);
            //application.selectComponent( application.addComponent({ type: "rgb-light" }) );
            return;
        };

        // Shortcut: F1
        if(event.which == 112){
            event.preventDefault();
            presenter.getWindow("databaseManager").show(undefined, { "command": "upload" });
            presenter.menu.deselectCurrentMenu();
            //application.selectComponent( application.addComponent({ type: "rgb-light" }) );
            return;
        };

        //Disable back
        /*if(event.which == 8){
            //alert();
            //event.preventDefault();
            return false;
        };*/

        //console.warn(event.which);
        //console.warn(String.fromCharCode(event.which));
        //console.warn(String.fromCharCode(event.which).toLowerCase());

        //Backward/Forward
        if( (String.fromCharCode(event.which).toLowerCase() == 'b' || String.fromCharCode(event.which).toLowerCase() == 'f') && application.getSelectMapComponent() != undefined){
            var oNode = application.getSelectMapComponent();
            var oMapComponent = oNode.getData();
            var $elem = $("#"+ oMapComponent.id)

            if($elem.is(":visible") && event.ctrlKey){

                switch(String.fromCharCode(event.which).toLowerCase()){
                    case "f":
                        var oMap = application.getSelectMap().getData();
                        var $viewer = $elem.parent();

                        //console.error( $viewer.find(".map-element").index($elem) );

                        $elem.next().after($elem);

                        var iNewIndex = $viewer.find(".map-element").index($elem);
                        var iOldIndex = oMap.components.indexOf(oNode);

                        //console.error( $viewer.find(".map-element").index($elem) );
                        //console.error( oMap.components.indexOf(oData) );

                        oMap.components.splice(iNewIndex,0,oMap.components.splice(iOldIndex,1)[0]);
                        break;
                    case "b":
                        var oMap = application.getSelectMap().getData();
                        var $viewer = $elem.parent();

                        //console.error( $viewer.find(".map-element").index($elem) );

                        $elem.prev().before($elem);

                        var iNewIndex = $viewer.find(".map-element").index($elem);
                        var iOldIndex = oMap.components.indexOf(oNode);

                        //console.error( $viewer.find(".map-element").index($elem) );
                        //console.error( oMap.components.indexOf(oData) );

                        oMap.components.splice(iNewIndex,0,oMap.components.splice(iOldIndex,1)[0]);

                        break;
                }
            }
        }

        //TODO ARROWS 37 38 39 40
        /*if(event.which == 37 && application.getSelectMapComponent() != undefined){
            var oNode = application.getSelectMapComponent();
            var oMapComponent = oNode.getData();
            var $elem = $("#"+ oMapComponent.id)

            if($elem.is(":visible")){
                var step = (presenter.preferences.getInterfacePreference("gridEnabled"))?parseInt(presenter.preferences.getInterfacePreference("grid")[0]):20;
                if(event.ctrlKey){
                    step = 100;
                }
                var oPosition = $.extend(true,{},oMapComponent.position);

                switch(event.which){
                    case 37:
                        oPosition.x -= step;
                        break;
                    case 38:
                        oPosition.y += step;
                        break;
                    case 39:
                        oPosition.x += step;
                        break;
                    case 40:
                        oPosition.y -= step;
                        break;
                }

                //Change only model
                $.publish("/model/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/update/parameter",[oMapComponent,"position",oPosition]);
                $.publish("/view/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/refresh/parameter",[oMapComponent,"position",oPosition]);
            }
        }*/

        // Shortcut: canc (Remove components)
        /*if((event.which == 46) && !event.ctrlKey && !event.altKey && !event.shiftKey){
            event.preventDefault();

            //console.error("CANC");

            if(application.getSelectGateway() != undefined && $("#gateways").is(":visible")){
                application.removeGateway(application.getSelectGateway());
            }
            else if(application.getSelectComponent() != undefined && $("#createcomponents").is(":visible")){
                var oNode = application.getSelectComponent();
                var oComponent = oNode.getData();
                var $nextElement = $("#"+ oComponent.id).next();
                var oNextNode = $nextElement.data("eveManagerNode");

                if(oComponent.getParamVal("special") != undefined){
                    console.warn("Can not remove "+ oComponent.getParamVal("special") +" component");
                    return;
                }
                application.removeComponent(oNode);
                application.selectComponent(oNextNode);
            }
            else if(application.getSelectUIComponent() != undefined && $("#interface").is(":visible")){
                if(presenter.preferences.getParameter("view") == "classic"){
                    application.removeUIComponent(application.getSelectUIComponent());
                }
                else{
                    //TODO rimuovere componenti nella mappa
                    //application.removeUIComponent(application.getSelectUIComponent());
                    application.removeMapComponentFrom(application.getSelectMapComponent(),application.getSelectMap());
                }
            }

            return false;
        }*/


        //alert(event.which);
        //alert(String.fromCharCode(event.which));

        /*console.log((event.which == 91));
        console.log(( String.fromCharCode(event.which).toLowerCase() == 's'));
        if((event.which == 91) && ( String.fromCharCode(event.which).toLowerCase() == 's') || (event.which == 19)){
            event.preventDefault();
            console.debug("SAVE MAC");
            return false;
        }
        
        if (event.which == 115 && (event.metaKey) || (event.which == 19)){
            event.preventDefault();
            console.debug("SAVE MAC");
            return false;
        }*/

        // Shortcut: ctrl + alt + D (enable context menu context menu)
        if( String.fromCharCode(event.which).toLowerCase() == 'd' && event.ctrlKey && event.altKey ){
            var $body = $("body");

            var $div = $("<div style='position: absolute; bottom: 50px; right: 50px; font-size: 32px; background-color: #222; color: yellow; padding: 30px; border-radius: 30px; opacity: 0; display: block;'></div>");
            $("body").append($div);

            //Debug mode ON
            if($body.attr("oncontextmenu") != undefined){
                $body.removeAttr("oncontextmenu");
                $div.text("DEBUG MODE: ON");
                $div.animate({ opacity:.9 },200);
                $div.animate({ opacity: 0 },{
                    duration: 200,
                    complete: function(){
                        $div.remove();
                    }
                });
            }
            //Debug mode OFF
            else{
                $body.attr("oncontextmenu","return false;");
                $div.text("DEBUG MODE: OFF");
                $div.animate({ opacity:.9 },200);
                $div.animate({ opacity: 0 },{
                    duration: 200,
                    complete: function(){
                        $div.remove();
                    }
                });
            }
            return;
        };
        
        if (! (String.fromCharCode(event.which).toLowerCase() == 's' && event.ctrlKey) && !(event.which == 19))
        {
            return true;
        }

        event.preventDefault();
        //return false;
    });
    
});
