/**
 * Created by blr on 21/04/15.
 */
"use strict";

var VERSION = "v.1.0.2";
var NAME = "Vivaldi Group Giove Free Wizard " + VERSION;
var $ = jQuery;

try {
    console.log("%cStart " + NAME, "color:DarkSlateBlue");
    create_gui();
    console.log("%cEnd " + NAME, "color:DarkSlateBlue");
} catch (err) {
    console.error(NAME + " error\n" + err);
    alert(NAME + " error\n" + err);
}

function create_gui(){
    var wizard = $("<div id='vivaldigroupgiovefree-wizard' title='" + NAME + "'></div>");
    wizard.append("</br><label>Name</label></br>");
    wizard.append("<input type='text' id='gtw-name' value='Vivaldi Giove Free'/></br>");
    wizard.append("</br><label>Address</label></br>");
    wizard.append("<input type='text' id='gtw-address' value='192.168.0.101'/></br>");
    //wizard.append("<input type='text' id='gtw-address' value='192.168.1.254'/></br>");
    wizard.append("</br><label>Port</label></br>");
    wizard.append("<input type='text' id='gtw-port' value='10001' onkeypress='bigh.onlyPosInt();' /></br>");
    //wizard.append("<input type='text' id='gtw-port' value='1001' onkeypress='bigh.onlyPosInt();' /></br>");
    wizard.append("</br><label>Numbers of controllers</label></br>");
    wizard.append("<input type='text' id='controllers-count' value='10' onkeypress='bigh.onlyPosInt();' /></br>");
    $("body").append(wizard);

    wizard.dialog({
        modal:true,
        width:350,
        close: function() {
            $( this ).remove();
        },
        buttons: {
            "Create Componens...": function() {
                $( this ).dialog( "close" );
                $( this ).remove();

                main(
                    $(this).children("#gtw-name").val(),
                    $(this).children("#gtw-address").val(),
                    $(this).children("#gtw-port").val(),
                    $(this).children("#controllers-count").val()
                );
            },
            Cancel: function() {
                $( this ).dialog( "close" );
                $( this ).remove();
            }
        }
    });

    return wizard;
}

function main(name, ip, port, numControllers){
    try {
        if (numControllers > 60) {
            numControllers = 60;
        }

        var oGateway = getGateway(name, ip, port);
        var oGroup = getMainGroup(name);

        blr.executionStack.show(NAME);

        for (var i = 0; i < numControllers; ++i) {
            blr.executionStack.push(
                function (in_args,out_args) {
                    out_args = createRoomController(in_args.gateway,in_args.group,in_args.index);
                },
                {
                    gateway:oGateway,
                    group:oGroup,
                    index:i + 1
                }
            );
        }

        blr.executionStack.execute(10,true);

    } catch (err) {
        console.error(NAME + " error\n" + err);
        alert(NAME + " error\n" + err);
    }
}

function createRoomController(gateway, group, id) {
    var oItem = null;
    var oGroup = application.addComponent({
        type: "group",
        name: _D("RC") + " " + id
    }, group);

    // Power
    oItem = application.addComponent({
        type: "switch",
        gateway: gateway,
        name: id + " " + _D("Power"),
        "vivaldigiovefree/device-id": id,
        "vivaldigiovefree/device-fid": 0,
        "icons": [
            blr.gfxResource.getIconByTypeName(0, "off"),
            blr.gfxResource.getIconByTypeName(1, "on")
        ]
    }, oGroup);
    // Mute
    oItem = application.addComponent({
        type: "switch",
        gateway: gateway,
        name: id + " " + _D("Mute"),
        "vivaldigiovefree/device-id": id,
        "vivaldigiovefree/device-fid": 1,
        "icons": [
            blr.gfxResource.getIconByTypeName(0, "sound"),
            blr.gfxResource.getIconByTypeName(1, "mute")
        ]
    }, oGroup);
    // Sources
    oItem = application.addComponent({
        type: "combo",
        gateway: gateway,
        name: id + " " + _D("Source"),
        "vivaldigiovefree/device-id": id,
        "vivaldigiovefree/device-fid": 2,
        "values": [{
            "value": 1,
            "description": _D("Tuner")
        }, {
            "value": 2,
            "description": _D("Cd")
        }, {
            "value": 3,
            "description": _D("Dvd")
        }, {
            "value": 4,
            "description": _D("Tv")
        }, {
            "value": 5,
            "description": _D("Dvr")
        }, {
            "value": 6,
            "description": _D("Aux 1")
        }, {
            "value": 7,
            "description": _D("Aux 2")
        }, {
            "value": 8,
            "description": _D("Mp3")
        }, {
            "value": 9,
            "description": _D("Aux In")
        }, {
            "value": 10,
            "description": _D("Mic Base")
        }, {
            "value": 11,
            "description": _D("Usb")
        }, {
            "value": 12,
            "description": _D("Mic In")
        }, {
            "value": 13,
            "description": _D("Mic Out")
        }, {
            "value": 14,
            "description": _D("Bluetooth")
        }],
        "icons": [
            blr.gfxResource.getIconByTypeName(1, "tuner"),
            blr.gfxResource.getIconByTypeName(2, "cd"),
            blr.gfxResource.getIconByTypeName(3, "dvd"),
            blr.gfxResource.getIconByTypeName(4, "tv"),
            blr.gfxResource.getIconByTypeName(5, "dvr"),
            blr.gfxResource.getIconByTypeName(6, "one"),
            blr.gfxResource.getIconByTypeName(7, "two"),
            blr.gfxResource.getIconByTypeName(8, "mp3"),
            blr.gfxResource.getIconByTypeName(9, "in"),
            blr.gfxResource.getIconByTypeName(10, "mic"),
            blr.gfxResource.getIconByTypeName(11, "usb"),
            blr.gfxResource.getIconByTypeName(12, "mic_in"),
            blr.gfxResource.getIconByTypeName(13, "mic_out"),
            blr.gfxResource.getIconByTypeName(14, "bluetooth")
        ]
    }, oGroup);

    // Volume
    oItem = application.addComponent({
        type: "slider",
        gateway: gateway,
        name: id + " " + _D("Volume"),
        "vivaldigiovefree/device-id": id,
        "vivaldigiovefree/device-fid": 3,
        "icons": [
            blr.gfxResource.getIconByTypeName(0, "volume")
        ]
    }, oGroup);
    // Low
    oItem = application.addComponent({
        type: "tuner",
        gateway: gateway,
        name: id + " " + _D("Low"),
        digits: 1,
        min: "-10",
        max: "10",
        nolabel: false,
        step: "1",
        suffix: "db",
        "vivaldigiovefree/device-id": id,
        "vivaldigiovefree/device-fid": 4,
        "icons": [
            blr.gfxResource.getIconByTypeName(0, "volume"),
            blr.gfxResource.getIconByTypeName(1, "less"),
            blr.gfxResource.getIconByTypeName(2, "volume"),
            blr.gfxResource.getIconByTypeName(3, "plus")
        ]
    }, oGroup);
    // Middle
    oItem = application.addComponent({
        type: "tuner",
        gateway: gateway,
        name: id + " " + _D("Middle"),
        digits: 1,
        min: "-10",
        max: "10",
        nolabel: false,
        step: "1",
        suffix: "db",
        "vivaldigiovefree/device-id": id,
        "vivaldigiovefree/device-fid": 5,
        "icons": [
            blr.gfxResource.getIconByTypeName(0, "volume"),
            blr.gfxResource.getIconByTypeName(1, "less"),
            blr.gfxResource.getIconByTypeName(2, "volume"),
            blr.gfxResource.getIconByTypeName(3, "plus")
        ]
    }, oGroup);
    // High
    oItem = application.addComponent({
        type: "tuner",
        gateway: gateway,
        name: id + " " + _D("High"),
        digits: 1,
        min: "-10",
        max: "10",
        nolabel: false,
        step: "1",
        suffix: "db",
        "vivaldigiovefree/device-id": id,
        "vivaldigiovefree/device-fid": 6,
        "icons": [
            blr.gfxResource.getIconByTypeName(0, "volume"),
            blr.gfxResource.getIconByTypeName(1, "less"),
            blr.gfxResource.getIconByTypeName(2, "volume"),
            blr.gfxResource.getIconByTypeName(3, "plus")
        ]
    }, oGroup);
    // Tuner
    oItem = application.addComponent({
        type: "tuner",
        gateway: gateway,
        name: id + " " + _D("Tuner"),
        digits: 1,
        min: "87.5",
        max: "108.0",
        nolabel: false,
        step: "0.1",
        suffix: "MHz",
        "vivaldigiovefree/device-id": id,
        "vivaldigiovefree/device-fid": 7,
        "icons": [
            blr.gfxResource.getIconByTypeName(0, "tuner"),
            blr.gfxResource.getIconByTypeName(1, "less"),
            blr.gfxResource.getIconByTypeName(2, "tuner"),
            blr.gfxResource.getIconByTypeName(3, "plus")
        ]
    }, oGroup);

    ///////////////////////////////////////////
    // Info
    ///////////////////////////////////////////
    var aComponents = [0, 0];
    var oGroupInfo = application.addComponent({
        type: "group",
        name: id + " " + _D("Info")
    }, oGroup);
    // Rds String
    oItem = application.addComponent({
        type: "info",
        gateway: gateway,
        name: id + " Rds " + _D("Info"),
        "vivaldigiovefree/device-id": id,
        "vivaldigiovefree/device-fid": 100,
    }, oGroupInfo);
    // Cd String
    oItem = application.addComponent({
        type: "info",
        gateway: gateway,
        name: id + " Cd " + _D("Info"),
        "vivaldigiovefree/device-id": id,
        "vivaldigiovefree/device-fid": 101,
    }, oGroupInfo);
    // Track String
    oItem = application.addComponent({
        type: "info",
        gateway: gateway,
        name: id + " Track " + _D("Info"),
        "vivaldigiovefree/device-id": id,
        "vivaldigiovefree/device-fid": 102,
    }, oGroupInfo);

    // Optional Infos
    oItem = application.addComponent({
        type: "info",
        gateway: gateway,
        name: id + " Call " + _D("Info"),
        "vivaldigiovefree/device-id": id,
        "vivaldigiovefree/device-fid": 1000,
    }, oGroupInfo);
    oItem = application.addComponent({
        type: "info",
        gateway: gateway,
        name: id + " On/Off " + _D("Info"),
        "vivaldigiovefree/device-id": id,
        "vivaldigiovefree/device-fid": 0,
    }, oGroupInfo);
    oItem = application.addComponent({
        type: "info",
        gateway: gateway,
        name: id + " Mute " + _D("Info"),
        "vivaldigiovefree/device-id": id,
        "vivaldigiovefree/device-fid": 1,
    }, oGroupInfo);
    oItem = application.addComponent({
        type: "info",
        gateway: gateway,
        name: id + " Source ID " + _D("Info"),
        "vivaldigiovefree/device-id": id,
        "vivaldigiovefree/device-fid": 2,
    }, oGroupInfo);
    oItem = application.addComponent({
        type: "info",
        gateway: gateway,
        name: id + " Volume " + _D("Info"),
        "vivaldigiovefree/device-id": id,
        "vivaldigiovefree/device-fid": 3,
    }, oGroupInfo);
    oItem = application.addComponent({
        type: "info",
        gateway: gateway,
        name: id + " Low " + _D("Info"),
        "vivaldigiovefree/device-id": id,
        "vivaldigiovefree/device-fid": 4,
    }, oGroupInfo);
    oItem = application.addComponent({
        type: "info",
        gateway: gateway,
        name: id + " Middle " + _D("Info"),
        "vivaldigiovefree/device-id": id,
        "vivaldigiovefree/device-fid": 5,
    }, oGroupInfo);
    oItem = application.addComponent({
        type: "info",
        gateway: gateway,
        name: id + " Hight " + _D("Info"),
        "vivaldigiovefree/device-id": id,
        "vivaldigiovefree/device-fid": 6,
    }, oGroupInfo);
    oItem = application.addComponent({
        type: "info",
        gateway: gateway,
        name: id + " Tuner " + _D("Info"),
        "vivaldigiovefree/device-id": id,
        "vivaldigiovefree/device-fid": 7,
    }, oGroupInfo);

    var oGatewayGUI = application.getGatewaysByProtocol("gui")[0];
    ///////////////////////////////////////////
    // Track
    ///////////////////////////////////////////
    var aComponents = [0, 0];
    var oGroupTrack = application.addComponent({
        type: "group",
        name: id + " " + _D("Track")
    }, oGroup);
    // Track Prev
    oItem = application.addComponent({
        type: "scenario",
        gateway: gateway,
        name: id + " " + _D("Track") + " " + _D("Prev"),
        "vivaldigiovefree/device-id": id,
        "vivaldigiovefree/device-fid": 10,
        "vivaldigiovefree/value": 0,
    }, oGroupTrack);
    aComponents[0] = oItem.data.UId;
    // Track Next
    oItem = application.addComponent({
        type: "scenario",
        gateway: gateway,
        name: id + " " + _D("Track") + " " + _D("Next"),
        "vivaldigiovefree/device-id": id,
        "vivaldigiovefree/device-fid": 11,
        "vivaldigiovefree/value": 0,
    }, oGroupTrack);
    aComponents[1] = oItem.data.UId;
    // Seeker Tracks
    oItem = application.addComponent({
        type: "seeker",
        gateway: oGatewayGUI,
        name: id + " " + _D("Track"),
        "widget/components": aComponents,
        "icons": [
            blr.gfxResource.getIconByTypeName(0, "track_prev"),
            blr.gfxResource.getIconByTypeName(1, "track_next")
        ]
    }, oGroup);

    ///////////////////////////////////////////
    // CD
    ///////////////////////////////////////////
    aComponents = [0, 0];
    var oGroupCD = application.addComponent({
        type: "group",
        name: id + " " + _D("CD")
    }, oGroup);

    // CD Prev
    oItem = application.addComponent({
        type: "scenario",
        gateway: gateway,
        name: id + " " + _D("CD") + " " + _D("Prev"),
        "vivaldigiovefree/device-id": id,
        "vivaldigiovefree/device-fid": 8,
        "vivaldigiovefree/value": 0,
    }, oGroupCD);
    aComponents[0] = oItem.data.UId;
    // CD Next
    oItem = application.addComponent({
        type: "scenario",
        gateway: gateway,
        name: id + " " + _D("CD") + " " + _D("Next"),
        "vivaldigiovefree/device-id": id,
        "vivaldigiovefree/device-fid": 9,
        "vivaldigiovefree/value": 0,
    }, oGroupCD);
    aComponents[1] = oItem.data.UId;
    // CD Tracks
    oItem = application.addComponent({
        type: "seeker",
        gateway: oGatewayGUI,
        name: id + " " + _D("CD"),
        "widget/components": aComponents,
        "icons": [
            blr.gfxResource.getIconByTypeName(0, "cd_prev"),
            blr.gfxResource.getIconByTypeName(1, "cd_next")
        ]
    }, oGroup);

    ///////////////////////////////////////////
    // Status
    ///////////////////////////////////////////
    aComponents = [0, 0];
    var oGroupStatus = application.addComponent({
        type: "group",
        name: id + " " + _D("Status")
    }, oGroup);

    // Play
    oItem = application.addComponent({
        type: "scenario",
        gateway: gateway,
        name: id + " " + _D("Play"),
        "vivaldigiovefree/device-id": id,
        "vivaldigiovefree/device-fid": 14,
        "vivaldigiovefree/value": 0,
    }, oGroupStatus);
    aComponents[0] = oItem.data.UId;
    // Pause
    oItem = application.addComponent({
        type: "scenario",
        gateway: gateway,
        name: id + " " + _D("Pause"),
        "vivaldigiovefree/device-id": id,
        "vivaldigiovefree/device-fid": 15,
        "vivaldigiovefree/value": 0,
    }, oGroupStatus);
    aComponents[1] = oItem.data.UId;
    // Status
    oItem = application.addComponent({
        type: "seeker",
        gateway: oGatewayGUI,
        name: id + " " + _D("Status"),
        "widget/components": aComponents,
        "icons": [
            blr.gfxResource.getIconByTypeName(0, "sound"),
            blr.gfxResource.getIconByTypeName(1, "pause")
        ]
    }, oGroup);
/*
    ///////////////////////////////////////////
    // Scenes
    ///////////////////////////////////////////
    // Create only once per type
    var oGroupIRScene = application.addComponent({
        type: "group",
        name: id + " " + _D("IRScene")
    }, oGroup);
    oItem = application.addComponent({
        type: "scenario",
        gateway: gateway,
        name: id + " " + _D("IRScene") + " 1",
        "vivaldigiovefree/device-id": id,
        "vivaldigiovefree/device-fid": 12,
        "vivaldigiovefree/value": 1,
        "icons": [blr.gfxResource.getIconByTypeName(0, "circle", 200, 0, 0)]
    }, oGroupIRScene);

    var oGroupScene = application.addComponent({
        type: "group",
        name: id + " " + _D("Scene")
    }, oGroup);
    oItem = application.addComponent({
        type: "scenario",
        gateway: gateway,
        name: id + " " + _D("Scene") + " 1",
        "vivaldigiovefree/device-id": id,
        "vivaldigiovefree/device-fid": 13,
        "vivaldigiovefree/value": 1,
    }, oGroupScene);
*/
    return oGroup;
}

function getGateway(name, address, port) {
    var oGateway = undefined;
    // Create Gateway
    var aGateways = application.getGatewaysByProtocol("vivaldigiovefree");
    if (aGateways.length > 0) {
        oGateway = aGateways[0];
    }

    if (oGateway == undefined) {
        oGateway = application.addGateway({
            name: name,
            protocol: "vivaldigiovefree"
        });
    }
    oGateway.data.setName(name);
    oGateway.data.setParamVal("vivaldigiovefree/address", address);
    oGateway.data.setParamVal("vivaldigiovefree/port", port);
    return oGateway;
}

function getMainGroup(name) {
    var oGroup = application.addComponent({
        type: "group",
        name: name
    });
    return oGroup;
}